#ifndef BST_H
#define BST_H

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>

#include "dynarray.h"


////////////////////////////////////////////////////////////////////////////////
// BINARY SEARCH TREE (BST) STRUCTURE
////////////////////////////////////////////////////////////////////////////////

typedef struct bstnode {
    data_t data;
    struct bstnode *left;
    struct bstnode *right;
} bstnode_t;

typedef struct bst {
    bstnode_t *root;
    size_t size;
} bst_t;


////////////////////////////////////////////////////////////////////////////////
// BINARY SEARCH TREE (BST) METHODS
////////////////////////////////////////////////////////////////////////////////

// Constructors and memory management:
void bst_init(bst_t *tree);   // Constructor: Creates an empty bst
void bst_free(bst_t *tree);   // Frees the nodes stored in the tree
void bst_build(bst_t *tree, data_t array[], size_t length);

bool bst_find(bst_t *tree, data_t x); // Finds if x is in the tree
void bst_range_search(bst_t *tree, data_t range_min, data_t range_max, dynarray_t *output_array);

#endif
