#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#include "dynarray.h"
#include "drawtree.h"
#include "bst.h"

int main() {

    data_t array[] = {5, 2, 3, 4, 1, 7, 9, 12, 0, 16};

    // Initialize binary search tree (BST)
    bst_t tree;
    bst_init(&tree);
    bst_build(&tree, array, 10);

    // Ad-hoc tests for find()
    printf("find(4)---should be true:  %s\n", bst_find(&tree, 4)  ? "true" : "false");
    printf("find(10)--should be false: %s\n", bst_find(&tree, 10) ? "true" : "false");

    // Ad-hoc tests for bst_range_search()
    dynarray_t output_array;
    dynarray_init(&output_array);
    bst_range_search(&tree, 4, 12, &output_array);
    turtle_draw_bst(&tree, &output_array);
    printf("Items in [4, 12]: ");
    while (!dynarray_is_empty(&output_array)) {
        printf("%d ", dynarray_pop(&output_array));
    }
    printf("\n");

    // Clean up
    dynarray_free(&output_array);
    bst_free(&tree);
    return EXIT_SUCCESS;
}
