#ifndef HELPERS_H
#define HELPERS_H

#include <stdbool.h>

////////////////////////////////////////////////////////////////////////////////
// Helper Structures
////////////////////////////////////////////////////////////////////////////////

// A structure for representing a 2D point with x and y coordinates.
typedef struct point {
    float x, y;
} point_t;

// A piece of debris has a position and a flag for whether it is active or not
// For your purposes you can ignore the active flag.
typedef struct debris {
    point_t pos; // The position of the debris
    bool active; // true if the debris is not destroyed
} debris_t;

// A bbox_t represents a box range for all x values between .minx and .maxx
// and all y values between .miny and .maxy
typedef struct bbox {
    float minx, maxx, miny, maxy;
} bbox_t;

////////////////////////////////////////////////////////////////////////////////
// Helper Functions
////////////////////////////////////////////////////////////////////////////////

float dist_sq(point_t p, point_t q); // Squared distance between p and q (fast)
float dist(point_t p, point_t q); // Distance between p and q (slow)

#endif
